/*
	Lucky Number for MonaOS:BayGUI
    Ver0.2 (2007-10-24)
	Copyright (c) 2007 Akkiesoft.
	License: KL-01 (see license.txt)
*/

#include <baygui.h>


class Uro2mous : public Frame
{
private:
	MonAPI::Random random;
	MessageInfo info;
	Button *button1;
	dword pid;
	int i, x, y;

public:

	Uro2mous::Uro2mous() {
		random.setSeed(MonAPI::System::getTick());
		pid = monapi_get_server_thread_id(ID_MOUSE_SERVER);

		setBounds(150, 30, 120, 78);
		setTitle("うろうろまうす");

		button1 = new Button("おわり");
		button1->setBounds(0, 0, 107, 50);
		add(button1);

		setTimer(100);
	}

	Uro2mous::~Uro2mous()
	{
	}

	void processEvent(Event *event) {
		if (event->getType() == MouseEvent::MOUSE_RELEASED) {
			// 更新を押したとき
			if (event->getSource() == button1) {
				Window::stop();		// アプリを安全に終了
			}
			return;
		}

		if (event->getType() == Event::TIMER) {
			MonAPI::Message::sendReceive(&info, pid, MSG_MOUSE_GET_CURSOR_POSITION);
			x = info.arg2;
			y = info.arg3;
			i = random.nextInt() % 4;
			if (i == 0)
				y += 5;
			else if (i == 1)
				x += 5;
			else if (i == 2)
				y -= 5;
			else if (i == 3)
				x -= 5;
			MonAPI::Message::sendReceive(NULL, pid, MSG_MOUSE_SET_CURSOR_POSITION, x, y);
			setTimer(100);
		}
	}

};

int main(int argc, char* argv[]) {
	Uro2mous *uro2mous = new Uro2mous();
	uro2mous->run();
	delete(uro2mous);
	return 0;
}
